<?php

/*
 * EverList - A free email listserv written in PHP.
 * Copyright (C) 2008 by Kris Craig.
 * 07.20.2008
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

require( "config.php" );
require( "common.php" );

foreach ( $_GET as $getvar => $getval )
{
	$$getvar = $getval;
}

foreach ( $_POST as $postvar => $postval )
{
	$$postvar = $postval;
}

$userdata = array();
$userdata = AuthenticateUser();
if ( $userdata["authstatus"] != 1 )
{
	UserLogin( $userdata["authstatus"] );
	die();
}

$profiledata = array();
$profiledata = $topdata["profiledata"];

$forumdata = array();
$forumdata = LoadForum( $profiledata["currentforumid"] );

$postdata = array();
$postdata = LoadPost( $pid );

if ( $postdata["success"] == FALSE )
{
	GenerateHeader( "EverList - Submission Error", TRUE );
	$topdata = array();
	$topdata = GenerateTop( $userdata );
	
	print "<b style=\"color: red\">";
	print $postdata["errmsg"];
	print "</b>";
	
	GenerateBottom();
	GenerateFooter();
	die();
}

if ( $postdata["createdbyuserid"] != $userdata["userid"] 
	&& strcasecmp( $userdata["status"], "ADMIN" ) )
{
	GenerateHeader( "EverList - Submission Error", TRUE );
	$topdata = array();
	$topdata = GenerateTop( $userdata );
	
	print "<b style=\"color: red\">";
	print "ACCESS DENIED!";
	print "</b>";
	
	GenerateBottom();
	GenerateFooter();
	die();
}

if ( strcasecmp( $postdata["pstatus"], "NEW" ) )
{
	GenerateHeader( "EverList - Submission Error", TRUE );
	$topdata = array();
	$topdata = GenerateTop( $userdata );
	
	print "<b style=\"color: red\">";
	print "You cannot edit this post!  It has already been emailed out.";
	print "</b>";
	
	GenerateBottom();
	GenerateFooter();
	die();
}

if ( $formstage == 1 )
{
	if ( trim( $postbody ) == NULL || strlen( trim( $postbody ) ) < 2 )
	{
		GenerateHeader( "EverList - Submission Error", TRUE );
		$topdata = array();
		$topdata = GenerateTop( $userdata );
		
		print "Post body must be at least 2 characters in length!  Please hit your browser's back button and correct the error.";
		
		GenerateFooter();
		die();
	}
	else if ( strlen( $postbody ) > 204800 )
	{
		GenerateHeader( "EverList - Submission Error", TRUE );
		$topdata = array();
		$topdata = GenerateTop( $userdata );
		
		/* Just a stop-gap security measure.  Better safe than sorry.  --Kris */
		print "Post body cannot exceed 200 KB in length!  Please hit your browser's back button and correct the error.";
		
		GenerateFooter();
		die();
	}
	else if ( strlen( $topicname ) > 70 )
	{
		GenerateHeader( "EverList - Submission Error", TRUE );
		$topdata = array();
		$topdata = GenerateTop( $userdata );
		
		/* Anything more and it won't fit in 1024x768....  --Kris */
		print "Post subject cannot exceed 70 characters in length!  Please hit your browser's back button and correct the error.";
		
		GenerateFooter();
		die();
	}
	
	/* Whew!  Everything passed!  Allow the new post.  --Kris */
	$cur_time = time();
	
	$postbody = addslashes( trim( $postbody ) );
	
	$query = "update posts set ptext='$postbody', excludeptext='$excludemessage', ";
	$query .= "plastedittimestamp='$cur_time' where pid='$pid'";
	$resulttl1 = mysql_query( $query ) or die( "Query '$query' failed for resulttl1 in editpost.php : " . mysql_error() );
	
	header( "Location: viewtopic.php?tid=" . $postdata["tid"] . "&editpost=1#" . $pid );
}

GenerateHeader( "EverList - Delete Post", TRUE, TRUE );
$topdata = array();
$topdata = GenerateTop( $userdata );

if ( $postdata["excludeptext"] == 1 )
{
	$extext = " checked";
}
else
{
	$extext = NULL;
}

?>
<h2>Edit Your Post</h2>
<b style="color: red">WARNING</b>
<br />
<span style="font-size: 10pt; color: #880000">
Make your changes quickly.
<br />
If your post is emailed out before you submit your changes, they will be automatically rejected.
<br />
If you need more time, you may wish to consider deleting your post and starting over.
</span>

<br />
<br />

<form name="editform" action="editpost.php" method="POST">

<input type="hidden" name="formstage" value="1" />
<input type="hidden" name="pid" value="<?php print $pid; ?>" />

<textarea name="postbody" rows="5" cols="30"><?php print $postdata["ptext"]; ?></textarea>

<br />

<input type="checkbox" name="excludemessage" value="1"<?php print $extext; ?> /> 
<a class="info">Exclude message text from email<font size="-1" color="green"> <sup>[?]</sup></font><span>
<b style="color: red; font-size: 12pt">WARNING:</b>
<br />
Your post will be emailed to every subscribed user who has opted to receive digest emails 
for this forum.
<br />
<br />
Many email clients, including Gmail and Outlook, have very limited 
support for rich-text HTML formatting.  Though basic font styling and images generally 
have universal support, please be aware that excessively "fancy" formatting of your 
text may result in your post getting "garbled" or filtered by some recipients with 
incompatible email clients.
<br />
<br />
If you wish to use a lot of formatting anyway and are concerned that some 
email clients might garble it up, check the box below to have the email contain only a 
direct link to your post on this website, without the message text itself.  Please note 
that this link will be included in every digest email anyway, regardless of whether or not the 
message exclusion box is checked.
</span></a>

<br />
<br />

<input type="submit" name="submitform" value="Save Changes" />

</form>

<?php
GenerateBottom();
GenerateFooter();
