<?php

/*
 * EverList - A free email listserv written in PHP.
 * Copyright (C) 2008 by Kris Craig.
 * 07.20.2008
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

require( "common.php" );

foreach ( $_GET as $getvar => $getval )
{
	$$getvar = $getval;
}

$userdata = array();
$userdata = AuthenticateUser();
if ( $userdata["authstatus"] != 1 && $fid == NULL )
{
	UserLogin( $userdata["authstatus"] );
	die();
}

GenerateHeader( "EverList - Messages", TRUE );
$topdata = array();
$topdata = GenerateTop( $userdata );

if ( $fid != NULL )
{
	$forumdata = array();
	$forumdata = LoadForum( $fid );
	
	if ( $forumdata["success"] == TRUE )
	{
		$topdata["profiledata"]["currentforumid"] = $fid;
		$topdata["forumdata"] = array();
		$topdata["forumdata"] = $forumdata;
	}
	else if ( $userdata["authstatus"] != 1 )
	{
		UserLogin( $userdata["authstatus"], FALSE );
		print "<br />Invalid fid - $fid";
		GenerateFooter();
		die();
	}
}

if ( trim( $topdata["profiledata"]["currentforumid"] ) == NULL 
	|| $topdata["forumdata"]["success"] == FALSE )
{
	print "You must select a forum before you can view messages.";
	GenerateBottom();
	GenerateFooter();
	die();
}

$isadmin = CheckUserAdmin();

$forumdata = array();
$forumdata = $topdata["forumdata"];

if ( $forumdata["isclosed"] == 1 
	|| ( $forumdata["isclosed"] == 3 && $isadmin == FALSE ) )
{
	print "<b style=\"color: red\">";
	print "This forum is currently CLOSED.  Please contact the listserv administrator for further information.";
	print "</b>";
	
	GenerateBottom();
	GenerateFooter();
	die();
}

$query = "select * from topics where fid='" . $topdata["profiledata"]["currentforumid"] . "' order by ttimestamp DESC, tname ASC";
$resulttl1 = mysql_query( $query ) or die( "Query 'query' failed for resulttl1 in messages.php : " . mysql_error() );

$topics = array();
$topics[0] = 0;
while ( $line = mysql_fetch_array( $resulttl1, MYSQL_ASSOC ) )
{
	$topics[0]++;
	$topics[$topics[0]] = array();
	$sqloop = 0;
	foreach ( $line as $col_value )
	{
		$fieldname = mysql_field_name( $resulttl1, $sqloop );
		$topics[$topics[0]][$fieldname] = $col_value;
		$sqloop++;
	}
}

for ( $tloop = 1; $tloop <= $topics[0]; $tloop++ )
{
	$query = "select tid from posts where tid='" . $topics[$tloop]["tid"] . "'";
	$resulttl2 = mysql_query( $query ) or die( "Query 'query' failed for resulttl2 in messages.php : " . mysql_error() );
	
	$topics[$tloop]["replies"] = -1;
	while ( $line = mysql_fetch_array( $resulttl2, MYSQL_ASSOC ) )
	{
		$topics[$tloop]["replies"]++;
	}
}

$subscribed = IsSubscribed( $topdata["profiledata"], $topdata["forumdata"]["fid"] );

if ( $userdata["authstatus"] == 1 && ( $topdata["forumdata"]["ispublic"] == 1 || $subscribed == TRUE ) )
{
	/* Before we allow the post, check against the hourly/daily post limits.  --Kris */
	$limitreached = CheckPostLimitReached( $topdata["forumdata"], $userdata );
	
	if ( $limitreached == 0 )
	{
		/* Whew!  Everything passed!  Allow the new post.  --Kris */
		?>
		<b style="font-size: 14pt"><a href="newtopic.php?fid=<?php print $topdata["profiledata"]["currentforumid"]; ?>">Create New Topic</a></b>
	
		<br />
		<br />
		
		<?php
	}
}
	
if ( $topics[0] == 0 )
{
	print "There are no topics to display for this forum.";
}
else
{
	?>
	<table border="0" cellpadding="0" cellspacing="0" bgcolor="#FFFFFF"><tr><td><img src="images/space1px.gif" height=1 width=15 alt="" /></td><td align=right>
	
	<table border=0 width=749 cellpadding=3 cellspacing=1>
	<tr>
	<td bgcolor="#449944" width="26%"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'mcolumnshelp.php#datetime' );">Last Post</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
	<td bgcolor="#227722" width="50%"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'mcolumnshelp.php#subject' );">Subject</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
	<td bgcolor="#449944" width="4%"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'mcolumnshelp.php#replies' );">Replies</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
	<td bgcolor="#449944"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'mcolumnshelp.php#author' );">Author</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
	</tr>
	
	<?php
	/* If we somehow end up with an empty topic (no posts), skip it.  --Kris */
	$tmparr = array();
	$tmparr[0] = 0;
	for ( $tloop = 1; $tloop <= $topics[0]; $tloop++ )
	{
		if ( $topics[$tloop]["replies"] < 0 )
		{
			continue;
		}
		
		$tmparr[0]++;
		$tmparr[$tmparr[0]] = array();
		$tmparr[$tmparr[0]] = $topics[$tloop];
	}
	$topics = $tmparr;
	
	$rowcol[1] = "#C0F3C0";
	$rowcol[0] = "#90EE90";
	for ( $tloop = 1; $tloop <= $topics[0]; $tloop++ )
	{
		$pdata = array();
		$pdata = LoadProfile( $topics[$tloop]["createdbyuserid"] );
		
		?>
		<tr>
		<td bgcolor="<?php print $rowcol[$tloop % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><?php print date( "M d, Y @ g:i A (T)", $topics[$tloop]["ttimestamp"] ); ?></font></td>
		<td bgcolor="<?php print $rowcol[$tloop % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><b><a href="viewtopic.php?tid=<?php print $topics[$tloop]["tid"]; ?>"><?php print $topics[$tloop]["tname"]; ?></a></b></font></td>
		<td bgcolor="<?php print $rowcol[$tloop % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><?php print $topics[$tloop]["replies"]; ?></font></td>
		<td bgcolor="<?php print $rowcol[$tloop % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><a class="darklink" href="viewprofile.php?userid=<?php print $pdata["userid"]; ?>"><?php print $pdata["fullname"]; ?></a></font></td>
		</tr>
		<?php
	}
}

GenerateBottom();
GenerateFooter();
