<?php

/*
 * EverList - A free email listserv written in PHP.
 * Copyright (C) 2008 by Kris Craig.
 * 07.20.2008
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

require( "common.php" );

$userdata = array();
$userdata = AuthenticateUser();
if ( $userdata["authstatus"] != 1 )
{
	UserLogin( $userdata["authstatus"] );
	die();
}

GenerateHeader( "EverList - My Forums", TRUE );
$topdata = array();
$topdata = GenerateTop( $userdata );

$profiledata = array();
$profiledata = LoadProfile( $userdata["userid"] );

$subforums = array();
$subforums = GetWords( $profiledata["subscribedforumids"] );

if ( $subforums[0] == 0 )
{
	print "There are no forums to display.";
}
else
{
	/* So newest subscriptions are displayed on top.  --Kris */
	$subforums = array_reverse( $subforums, TRUE );
	
	$forumsdata = array();
	$forumsdata[0] = 0;
	
	foreach ( $subforums as $subkey => $subval )
	{
		if ( $subkey == 0 )
		{
			continue;
		}
		
		$forumsdata[0]++;
		$forumsdata[$forumsdata[0]] = array();
		$forumsdata[$forumsdata[0]] = LoadForum( $subval );
	}
	
	?>
	<table border="0" cellpadding="0" cellspacing="0" bgcolor="#FFFFFF"><tr><td><img src="images/space1px.gif" height=1 width=15 alt="" /></td><td align=right>
	
	<table border=0 width=749 cellpadding=3 cellspacing=1>
	<tr>
	<td bgcolor="#227722"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'columnshelp.php#name' );">Name</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
	<td bgcolor="#449944"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'columnshelp.php#description' );">Description</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
	<td bgcolor="#449944" width="11%"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'columnshelp.php#public' );">Public?</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
	<td bgcolor="#449944" width="10%"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=center><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'columnshelp.php#subscribe' );">Unsubscribe?</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
	</tr>
	
	<?php
	$rowcol[1] = "#C0F3C0";
	$rowcol[0] = "#90EE90";
	for ( $floop = 1; $floop <= $forumsdata[0]; $floop++ )
	{
		if ( $forumsdata[$floop]["ispublic"] == 1 )
		{
			$pubtext = "Yes";
		}
		else if ( $forumsdata[$floop]["ispublic"] == 2 )
		{
			$pubtext = "Viewing Only";
		}
		else
		{
			$pubtext = "No";
		}
		
		if ( !IsSubscribed( $profiledata, $forumsdata[$floop]["fid"] ) )
		{
			$subtext = "Subscribe";
			$subimg = "subscribe.gif";
		}
		else
		{
			$subtext = "Unsubscribe";
			$subimg = "unsubscribe.gif";
		}
		
		?>
		<tr>
		<td bgcolor="<?php print $rowcol[$floop % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><b><a class="forumname" title="select" href="viewforum.php?fid=<?php print $forumsdata[$floop]["fid"]; ?>"><?php print $forumsdata[$floop]["fname"]; ?></a></b></font></td>
		<td bgcolor="<?php print $rowcol[$floop % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><?php print $forumsdata[$floop]["fdescription"]; ?></font></td>
		<td bgcolor="<?php print $rowcol[$floop % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><?php print $pubtext; ?></font></td>
		<td bgcolor="<?php print $rowcol[$floop % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><nobr><center><a href="subscribe.php?fid=<?php print $forumsdata[$floop]["fid"]; ?>" title="<?php print $subtext; ?>"><img border=0 alt="<?php print $subtext; ?>" src="images/<?php print $subimg; ?>"></a></center></nobr></font></td>
		</tr>
		<?php
	}
}

GenerateBottom();
GenerateFooter();
